diff -uNr src.ORIG/mclibs/herwig/code/hwhegw.F src/mclibs/herwig/code/hwhegw.F
--- src.ORIG/mclibs/herwig/code/hwhegw.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhegw.F	2005-05-31 02:34:40.000000000 +0900
@@ -8,6 +8,9 @@
 C     BASED ON BOSON GLUON FUSION OF ABBIENDI AND STANCO
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,GMASS,EV(3),RV,LEP,Y,Q2,SHAT,Z,PHI,AJACOB,
      & DSIGMA,ME,MP,ML,MREMIF(18),MFIN1(18),MFIN2(18),RS,SMA,W2,RSHAT
       INTEGER LEPFIN,ID1,ID2,I,IQK,IFLAVU,IFLAVD,IMIN,IMAX,IFL,IPROO
@@ -28,8 +31,13 @@
         IDHW(8)=ID1
         IDHW(9)=ID2
         DO 1 I=4,9
+#if !defined(CERNLIB_GFORTRAN)
     1   IDHEP(I)=IDPDG(IDHW(I))
 C
+#else
+            IDHEP(I)=IDPDG(IDHW(I))
+    1   continue
+#endif
         IFLAVD=ID1
         IFLAVU=ID2-6
 C
@@ -118,11 +126,28 @@
         ELSEIF (IDHW(1).GE.127.AND.IDHW(1).LE.132) THEN
           LEP=-1.
         ENDIF
+#if !defined(CERNLIB_GFORTRAN)
         IF (LEP.EQ.0) CALL HWWARN('HWHEGW',500,*999)
+#else
+        if (LEP.EQ.0) then
+          call hwwarn('HWHEGW',500,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C---program only works if beam and target are charge conjugates
+#if !defined(CERNLIB_GFORTRAN)
         IF (LEP*(IDHW(2)-IDHW(1)).NE.6) CALL HWWARN('HWHEGW',501,*999)
+#else
+        IF (LEP*(IDHW(2)-IDHW(1)).NE.6) call hwwarn('HWHEGW',501,iret)
+        if (iret .eq. 1) go to 999
+#endif
 C---program only works for equal energy beams colliding
+#if !defined(CERNLIB_GFORTRAN)
         IF (PHEP(3,3).NE.0) CALL HWWARN('HWHEGW',503,*999)
+#else
+        IF (PHEP(3,3).NE.0) call hwwarn('HWHEGW',503,iret)
+        if (iret .eq. 1) go to 999
+#endif
 C
 C---FINAL STATE IS ALWAYS SET UP AS IF PARTICLE IS BEFORE ANTI-PARTICLE
 C   AND THEN INVERTED IF NECESSARY
@@ -148,7 +173,14 @@
           ID1  = 121
           ID2  = 128
 C---INTERFERENCE TERMS IN EE -> EE NUE NUEB  NEGLECTED: SIGMA UNRELIABLE
+#if !defined(CERNLIB_GFORTRAN)
           IF (FSTWGT) CALL HWWARN('HWHEGW',1,*999)
+#else
+          if (FSTWGT) then
+          call hwwarn('HWHEGW',1,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         ELSEIF (IQK.EQ.8) THEN
           IFLAVU=124
           IFLAVD=123
@@ -160,7 +192,12 @@
           ID1  = 125
           ID2  = 132
         ELSE
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWHEGW',504,*999)
+#else
+          call hwwarn('HWHEGW',504,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ENDIF
         IF (IQK.GT.0) THEN
           IF (IQK.LE.6) IQK=0
diff -uNr src.ORIG/mclibs/herwig/code/hwhegx.F src/mclibs/herwig/code/hwhegx.F
--- src.ORIG/mclibs/herwig/code/hwhegx.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhegx.F	2005-05-31 02:34:40.000000000 +0900
@@ -110,8 +110,13 @@
 C---SUM ALL TENSOR CONTRIBUTIONS
       DO 10 I=1,4
       DO 10 J=1,4
+#if !defined(CERNLIB_GFORTRAN)
  10     DSIGMA=DSIGMA + C(I,J)*D(I,J)
 C---CALCULATE TOTAL SUMMED AND AVERAGED MATRIX ELEMENT SQUARED
+#else
+           DSIGMA=DSIGMA + C(I,J)*D(I,J)
+ 10     continue
+#endif
       DSIGMA = DSIGMA * 2*CFAC*(4*PIFAC*ALPHEM)**3/SWEIN**2
 C---CALCULATE DIFFERENTIAL CROSS-SECTION
       DSIGMA = DSIGMA * GEV2NB*PHOTON/(512*PIFAC**4*ETA*EMSSQ)
diff -uNr src.ORIG/mclibs/herwig/code/hwhepa.F src/mclibs/herwig/code/hwhepa.F
--- src.ORIG/mclibs/herwig/code/hwhepa.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhepa.F	2005-05-31 02:34:40.000000000 +0900
@@ -29,7 +29,12 @@
           IQ=MAXFL
    11     IQ1=MAPQ(IQ)
           DO 20 I=1,7
+#if !defined(CERNLIB_GFORTRAN)
    20     CLF(I)=CLQ(I,IQ)
+#else
+             CLF(I)=CLQ(I,IQ)
+   20     continue
+#endif
         ELSE
           IQ1=ID1
         ENDIF
diff -uNr src.ORIG/mclibs/herwig/code/hwhepg.F src/mclibs/herwig/code/hwhepg.F
--- src.ORIG/mclibs/herwig/code/hwhepg.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhepg.F	2005-05-31 02:34:40.000000000 +0900
@@ -11,6 +11,9 @@
 C     EVWGT=sig(e^-e^+ --> qqbar g) in nb
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWUALF,HWUAEM,HWULDO,HWDPWT,Q2NOW,Q2LST,
      & PHASP,QGMAX,QGMIN,FACTR,QM2,CLF(7),ORDER,PRAN,PQWT,QQG,QBG,SUM,
      & RUT,QQLM,QQLP,QBLM,QBLP,DYN1,DYN2,DYN3,DYN4,DYN5,DYN6,XQ2,X2SUM,
@@ -80,7 +83,14 @@
         IF (Q2NOW.NE.Q2LST) THEN
           Q2LST=Q2NOW
           PHASP=3.*THMAX-2.
+#if !defined(CERNLIB_GFORTRAN)
           IF (PHASP.LE.0.) CALL HWWARN('HWHEPG',400,*999)
+#else
+          if (PHASP.LE.0.) then
+          call hwwarn('HWHEPG',400,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           QGMAX=.5*Q2NOW*THMAX
           QGMIN=.5*Q2NOW*(1.-THMAX)
           FACTR=GEV2NB*FLOAT(NCOLO)*CFFAC*HWUALF(1,EMSCA)
@@ -114,7 +124,12 @@
           IQ=MAXFL
    11     IQ1=MAPQ(IQ)
           DO 20 I=1,7
+#if !defined(CERNLIB_GFORTRAN)
    20     CLF(I)=CLQ(I,IQ)
+#else
+             CLF(I)=CLQ(I,IQ)
+   20     continue
+#endif
         ELSEIF (Q2NOW.GT.4*QM2/(2*THMAX-1)) THEN
           IQ1=ID1
         ELSE
diff -uNr src.ORIG/mclibs/herwig/code/hwhew0.F src/mclibs/herwig/code/hwhew0.F
--- src.ORIG/mclibs/herwig/code/hwhew0.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhew0.F	2005-05-31 02:34:40.000000000 +0900
@@ -37,7 +37,12 @@
       PR(2,1)=PR(5,1)*SC*COS(F)
       PR(1,1)=PR(5,1)*SC*SIN(F)
       DO 7 I=1,3
+#if !defined(CERNLIB_GFORTRAN)
 7     PR(I,2)=-PR(I,1)
+#else
+          PR(I,2)=-PR(I,1)
+7     continue
+#endif
       G=0.
       IF(IP.EQ.1)G=(D-C)*LOG((D+CX)/(D-CR))
       IF(IP.EQ.2)G=(D*D-C*C)/D*LOG((D+1.D0)/(D-1.D0))
diff -uNr src.ORIG/mclibs/herwig/code/hwhew1.F src/mclibs/herwig/code/hwhew1.F
--- src.ORIG/mclibs/herwig/code/hwhew1.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhew1.F	2005-05-31 02:34:40.000000000 +0900
@@ -16,7 +16,12 @@
   10  CONTINUE
       DO 20 J=1,4
       DO 30 K=1,(NPART-2)
+#if !defined(CERNLIB_GFORTRAN)
   30  PCM(J,K)=P(J,K+2)
+#else
+         PCM(J,K)=P(J,K+2)
+  30  continue
+#endif
       PCM(J,NPART-1)=-P(J,1)
       PCM(J,NPART)=-P(J,2)
   20  CONTINUE
diff -uNr src.ORIG/mclibs/herwig/code/hwhew2.F src/mclibs/herwig/code/hwhew2.F
--- src.ORIG/mclibs/herwig/code/hwhew2.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhew2.F	2005-05-31 02:34:40.000000000 +0900
@@ -26,7 +26,12 @@
 C FOLLOWING DO LOOP IS TO CONVERT TO OUR STANDARD INDEXING
       DO 1 L=1,NPART
       DO 1 IJ=1,4
+#if !defined(CERNLIB_GFORTRAN)
 1     P(IJ,L)=PPCM(IJ,L)
+#else
+          P(IJ,L)=PPCM(IJ,L)
+1     continue
+#endif
       DO 2 II=1,7
       WRN(II)=ONE
       IF(P(4,II).LT.ZERO) WRN(II)=-ONE
@@ -83,6 +88,11 @@
       DO 60 J=IPP1,NPART
       H(I,J)=-H(J,I)
       CH(I,J)=-CH(J,I)
+#if !defined(CERNLIB_GFORTRAN)
    60 D(I,J)=D(J,I)
+#else
+         D(I,J)=D(J,I)
+   60 continue
+#endif
       RETURN
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwhew3.F src/mclibs/herwig/code/hwhew3.F
--- src.ORIG/mclibs/herwig/code/hwhew3.F	1996-12-03 23:16:56.000000000 +0900
+++ src/mclibs/herwig/code/hwhew3.F	2005-05-31 02:34:40.000000000 +0900
@@ -50,6 +50,11 @@
 C 1 LEPTON FLAVOR IF APPROPRIATE FOR NFINAL CHOICE
       RKW=0.25D0/XW**2
       DO 6 I=1,4
+#if !defined(CERNLIB_GFORTRAN)
 6     AMPWW(I)=AMP2*COLFAC(I)*RKW*RKW
+#else
+          AMPWW(I)=AMP2*COLFAC(I)*RKW*RKW
+6     continue
+#endif
       RETURN
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwheww.F src/mclibs/herwig/code/hwheww.F
--- src.ORIG/mclibs/herwig/code/hwheww.F	1996-12-03 23:16:56.000000000 +0900
+++ src/mclibs/herwig/code/hwheww.F	2005-05-31 02:34:40.000000000 +0900
@@ -7,6 +7,9 @@
 C     E+E- -> W+W-/Z0Z0 (BASED ON ZOLTAN KUNSZT'S PROGRAM)
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       COMPLEX ZH,ZCH,ZD
       DOUBLE PRECISION HWUAEM,HWRGEN,HWUPCM,ETOT,STOT,FLUXW,GAMM,GIMM,
      & WM2,WXMIN,WX1MAX,WX2MAX,FJAC1,FJAC2,WX1,WX2,WMM1,WMM2,XXM,W2BO,
@@ -108,9 +111,19 @@
  50           CONTINUE
  60         CONTINUE
             DO 70 I=1,12
+#if !defined(CERNLIB_GFORTRAN)
  70           BRZED(I)=BRZED(I)/BRTOT
+#else
+                 BRZED(I)=BRZED(I)/BRTOT
+ 70           continue
+#endif
           ELSE
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWHEWW',500,*999)
+#else
+            call hwwarn('HWHEWW',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
           ENDIF
           GAMM=WMASS*WWIDTH
           GIMM=1.D0/GAMM
diff -uNr src.ORIG/mclibs/herwig/code/hwhiga.F src/mclibs/herwig/code/hwhiga.F
--- src.ORIG/mclibs/herwig/code/hwhiga.F	1996-12-03 23:16:56.000000000 +0900
+++ src/mclibs/herwig/code/hwhiga.F	2005-05-31 02:38:38.000000000 +0900
@@ -10,6 +10,10 @@
 C     Only top loop included. A factor (alpha_s**3*alpha_W) is extracted
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+      double complex imag
+#endif
       DOUBLE COMPLEX HWHIGB,HWHIGC,HWHIGD,HWHIG5,HWHIG1,HWHIG2,BI(4),
      & CI(7),DI(3),EPSI,TAMP(7)
       DOUBLE PRECISION S,T,U,EMH2,WTQQ,WTQG,WTGQ,WTGG,EMW2,RNGLU,RNQRK,
@@ -42,7 +46,12 @@
 C Small mass approximation in loops
          NOMASS=.TRUE.
       ELSE
+#if !defined(CERNLIB_GFORTRAN)
          CALL HWWARN('HWHIGA',500,*999)
+#else
+         call hwwarn('HWHIGA',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
 C Include only top quark contribution
       EMQ2=RMASS(6)**2
@@ -73,8 +82,13 @@
       TAMP(7)=HWHIG5(U,T,S,EMH2,EMQ2,3,0,6,0,0,0)
       DO 20 I=1,7
       TAMPI(I)= REAL(TAMP(I))
+#if !defined(CERNLIB_GFORTRAN)
   20  TAMPR(I)=-IMAG(TAMP(I))
 C Square and add prefactors
+#else
+         TAMPR(I)=-IMAG(TAMP(I))
+  20  continue
+#endif
       WTGG=0.03125*FLOAT(NCOLO*(NCOLO**2-1))
      &    *(TAMPR(1)**2+TAMPI(1)**2+TAMPR(2)**2+TAMPI(2)**2
      &     +TAMPR(3)**2+TAMPI(3)**2+TAMPR(4)**2+TAMPI(4)**2)*FLUXGG
diff -uNr src.ORIG/mclibs/herwig/code/hwhigb.F src/mclibs/herwig/code/hwhigb.F
--- src.ORIG/mclibs/herwig/code/hwhigb.F	1996-12-03 23:16:56.000000000 +0900
+++ src/mclibs/herwig/code/hwhigb.F	2005-05-31 04:38:33.000000000 +0900
@@ -2,7 +2,35 @@
 *CMZ :-        -23/08/94  13.22.29  by  Mike Seymour
 *-- Author :    Ulrich Baur & Nigel Glover, adapted by Ian Knowles
 C-----------------------------------------------------------------------
+#if !defined(CERNLIB_GFORTRAN)
       FUNCTION HWHIGB(NOMASS,S,T,EH2,EQ2)
+#else
+      FUNCTION HWHIGB(NOMASS,S,T,EH2,EQ2)
+      LOGICAL NOMASS
+      DOUBLE PRECISION S,T,EQ2,EH2
+      double complex hwhigb
+      hwhigb = hwhigsub(0,nomass,s,t,eth2,eq2)
+      return
+      end
+
+      FUNCTION HWHIGC(NOMASS,S,T,EH2,EQ2)
+      LOGICAL NOMASS
+      DOUBLE PRECISION S,T,EQ2,EH2
+      double complex hwhigc
+      hwhigc = hwhigsub(1,nomass,s,t,eth2,eq2)
+      return
+      end
+
+      FUNCTION HWHIGD(NOMASS,S,T,EH2,EQ2)
+      LOGICAL NOMASS
+      DOUBLE PRECISION S,T,EQ2,EH2
+      double complex hwhigd
+      hwhigd = hwhigsub(2,nomass,s,t,eth2,eq2)
+      return
+      end
+
+      FUNCTION HWHIGSUB(mode,NOMASS,S,T,EH2,EQ2)
+#endif
 C-----------------------------------------------------------------------
 C     One loop scalar integrals, used in HWHIGJ.
 C     If NOMASS=.TRUE. use a small mass approx. for particle in loop.
@@ -14,6 +42,15 @@
       LOGICAL NOMASS
       EXTERNAL HWULI2,HWUCI2
       COMMON/SMALL/EPSI
+#if defined(CERNLIB_GFORTRAN)
+      integer mode
+      double complex hwhigsub
+      if (mode .eq. 1) then
+         goto 1
+      else if (mode. eq. 2) then
+         goto 2
+      endif
+#endif
 C-----------------------------------------------------------------------
 C     B_0(2p1.p2=S;mq,mq)
 C-----------------------------------------------------------------------
@@ -34,9 +71,16 @@
      &                *(TWO*DLOG(DSQRT(RAT)+DSQRT(RAT-ONE))-PII)
          ENDIF
       ENDIF
+#if defined(CERNLIB_GFORTRAN)
+      hwhigsub = HWHIGB
+#endif
       RETURN
 C-----------------------------------------------------------------------
+#if !defined(CERNLIB_GFORTRAN)
       ENTRY HWHIGC(NOMASS,S,T,EH2,EQ2)
+#else
+ 1    continue
+#endif
 C-----------------------------------------------------------------------
 C     C_0(p{1,2}^2=0,2p1.p2=S;mq,mq,mq)
 C-----------------------------------------------------------------------
@@ -57,9 +101,16 @@
             HWHIGC=TWO*(COSH**2-PIFAC**2/FOUR-PII*COSH)/S
          ENDIF
       ENDIF
+#if defined(CERNLIB_GFORTRAN)
+      hwhigsub = HWHIGC
+#endif
       RETURN
 C-----------------------------------------------------------------------
+#if !defined(CERNLIB_GFORTRAN)
       ENTRY HWHIGD(NOMASS,S,T,EH2,EQ2)
+#else
+ 2    continue
+#endif
 C-----------------------------------------------------------------------
 C     D_0(p{1,2,3}^2=0,p4^2=EH2,2p1.p2=S,2p2.p3=T;mq,mq,mq,mq)
 C-----------------------------------------------------------------------
@@ -98,5 +149,8 @@
      &         *(LOG(EQ2+EPSI)-LOG(EQ2+EPSI-S*XP*XM)
      &          +LOG(EQ2+EPSI-EH2*XP*XM)-LOG(EQ2+EPSI-T*XP*XM)))
       ENDIF
+#if defined(CERNLIB_GFORTRAN)
+      hwhigsub = HWHIGD
+#endif
       RETURN
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwhigj.F src/mclibs/herwig/code/hwhigj.F
--- src.ORIG/mclibs/herwig/code/hwhigj.F	1996-12-03 23:16:56.000000000 +0900
+++ src/mclibs/herwig/code/hwhigj.F	2005-05-31 02:34:40.000000000 +0900
@@ -30,7 +30,12 @@
          IF (IDEC.EQ.0) THEN
             BR=0.
             DO 10 I=1,6
+#if !defined(CERNLIB_GFORTRAN)
   10        BR=BR+BRHIG(I)
+#else
+               BR=BR+BRHIG(I)
+  10        continue
+#endif
          ELSEIF (IDEC.EQ.10) THEN
             CALL HWDBOZ(198,ID1,ID2,CV,CA,BR,1)
             CALL HWDBOZ(199,ID1,ID2,CV,CA,BR,1)
diff -uNr src.ORIG/mclibs/herwig/code/hwhigm.F src/mclibs/herwig/code/hwhigm.F
--- src.ORIG/mclibs/herwig/code/hwhigm.F	1996-12-03 23:16:56.000000000 +0900
+++ src/mclibs/herwig/code/hwhigm.F	2005-05-31 02:34:21.000000000 +0900
@@ -23,6 +23,9 @@
 C     ENDIF
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRUNI,EM,WEIGHT,EMH,DIF,FUN,THETA,T,EMHLST,W0,
      & W1,EMM,GAMEM,T0,TMIN,TMAX,THEMIN,THEMAX,ZMIN,ZMAX,Z,F,GAMOFS
       INTEGER I
@@ -59,13 +62,25 @@
         F=0
  10     IF (I.LE.20 .AND. ABS(1-F/Z).GT.1E-4) THEN
           I=I+1
+#if !defined(CERNLIB_GFORTRAN)
           IF (2*ABS(THETA).GT.PIFAC) CALL HWWARN('HWHIGM',51,*999)
+#else
+          IF (2*ABS(THETA).GT.PIFAC) call hwwarn('HWHIGM',51,iret)
+        if (iret .eq. 1) go to 999
+#endif
           T=TAN(THETA)
           F=FUN(THETA,T,T0)
           THETA=THETA-(F-Z)/DIF(T,T0)
           GOTO 10
         ENDIF
+#if !defined(CERNLIB_GFORTRAN)
         IF (I.GT.20) CALL HWWARN('HWHIGM',1,*999)
+#else
+        if (I.GT.20) then
+          call hwwarn('HWHIGM',1,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       ELSE
         THETA=HWRUNI(0,THEMIN,THEMAX)
       ENDIF
@@ -88,6 +103,11 @@
         WEIGHT=W1*GAMOFS*EMM/GAMEM *((EM**2-EMH**2)**2 + GAMEM**2)
      &                             /((EM**2-EMH**2)**2 +(GAMOFS*EMM)**2)
       ELSE
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWHIGM',500,*999)
+#else
+        call hwwarn('HWHIGM',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
  999  END
diff -uNr src.ORIG/mclibs/herwig/code/hwhigs.F src/mclibs/herwig/code/hwhigs.F
--- src.ORIG/mclibs/herwig/code/hwhigs.F	1996-12-03 23:16:56.000000000 +0900
+++ src/mclibs/herwig/code/hwhigs.F	2005-05-31 02:34:40.000000000 +0900
@@ -17,7 +17,12 @@
         RWGT=HWRGEN(0)*EVSUM(13)
         IDN(1)=1
         DO 10 I=1,12
+#if !defined(CERNLIB_GFORTRAN)
  10       IF (RWGT.GT.EVSUM(I)) IDN(1)=I+1
+#else
+             IF (RWGT.GT.EVSUM(I)) IDN(1)=I+1
+ 10       continue
+#endif
         IDN(2)=13
         IF (IDN(1).LE.12) IDN(2)=IDN(1)-6
         IF (IDN(1).LE. 6) IDN(2)=IDN(1)+6
@@ -53,7 +58,12 @@
           IF (IDEC.EQ.0) THEN
             BRHIGQ=0
             DO 30 I=1,6
+#if !defined(CERNLIB_GFORTRAN)
  30           BRHIGQ=BRHIGQ+BRHIG(I)
+#else
+                 BRHIGQ=BRHIGQ+BRHIG(I)
+ 30           continue
+#endif
             BR=BRHIGQ
           ELSEIF (IDEC.EQ.10) THEN
             CALL HWDBOZ(198,ID1,ID2,CV,CA,BR,1)
diff -uNr src.ORIG/mclibs/herwig/code/hwhigw.F src/mclibs/herwig/code/hwhigw.F
--- src.ORIG/mclibs/herwig/code/hwhigw.F	1996-12-03 23:16:56.000000000 +0900
+++ src/mclibs/herwig/code/hwhigw.F	2005-05-31 02:34:40.000000000 +0900
@@ -145,7 +145,12 @@
         IF (IDEC.EQ.0) THEN
           BRHIGQ=0
           DO 20 I=1,6
+#if !defined(CERNLIB_GFORTRAN)
  20         BRHIGQ=BRHIGQ+BRHIG(I)
+#else
+               BRHIGQ=BRHIGQ+BRHIG(I)
+ 20         continue
+#endif
           WEIGHT=WEIGHT*BRHIGQ
         ENDIF
         IF (IDEC.EQ.10) THEN
@@ -297,7 +302,12 @@
               IDN(2)=2*HWRINT(1,4)-1
             ENDIF
             DO 62 I=1,2
+#if !defined(CERNLIB_GFORTRAN)
  62           IF (IDN(I).GE.5) IDN(I)=IDN(I)+2
+#else
+                 IF (IDN(I).GE.5) IDN(I)=IDN(I)+2
+ 62           continue
+#endif
             PROB=DISF(IDN(1),1)*DISF(IDN(2),2)*AZZ(2)/PZZ(2)
             IF (HWRGEN(0).GT.PROB) GOTO 61
             IDN(3)=IDN(1)
diff -uNr src.ORIG/mclibs/herwig/code/hwhigz.F src/mclibs/herwig/code/hwhigz.F
--- src.ORIG/mclibs/herwig/code/hwhigz.F	1996-12-03 23:16:56.000000000 +0900
+++ src/mclibs/herwig/code/hwhigz.F	2005-05-31 02:34:40.000000000 +0900
@@ -11,6 +11,9 @@
 C     MEAN EVWGT = CROSS-SECTION (IN NB) * HIGGS BRANCHING FRACTION
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWUAEM,HWHIGY,HWRUNI,HWRGEN,HWULDO,EMZ,CVE,CAE,
      & POL1,POL2,CE1,CE2,CE3,PMAX,EMZ2,S,B,FACTR,EMH,EMFAC,EMH2,A,XP,
      & CV,CA,BRHIGQ,BR,X1,X2,FAC1,FAC2,XPP,XPPSQ,COEF,X,XSQ,PROB,C1,C2,
@@ -59,7 +62,12 @@
         IF (IDEC.EQ.0) THEN
           BRHIGQ=0
           DO 10 I=1,6
+#if !defined(CERNLIB_GFORTRAN)
  10         BRHIGQ=BRHIGQ+BRHIG(I)
+#else
+               BRHIGQ=BRHIGQ+BRHIG(I)
+ 10         continue
+#endif
           EVWGT=EVWGT*BRHIGQ
         ENDIF
 C Add Z branching fractions
@@ -94,13 +102,25 @@
         NLOOP=0
         COEF=1./((12+2*A-12*XPP+XPPSQ)*SQRT(XPPSQ-A))
  20       NLOOP=NLOOP+1
+#if !defined(CERNLIB_GFORTRAN)
           IF (NLOOP.GT.NBTRY) CALL HWWARN('HWHIGZ',101,*999)
+#else
+          if (NLOOP.GT.NBTRY) then
+          call hwwarn('HWHIGZ',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           X=XP+B*TAN(HWRUNI(1,FAC1,FAC2))
           XSQ=X**2
           PROB=COEF*((12+2*A-12*X+XSQ)*SQRT(XSQ-A))
           IF (PROB.GT.PMAX) THEN
             PMAX=1.1*PROB
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWHIGZ',1,*999)
+#else
+            call hwwarn('HWHIGZ',1,iret)
+        if (iret .eq. 1) go to 999
+#endif
             WRITE (6,21) PMAX
  21         FORMAT(7X,'NEW HWHIGZ MAX WEIGHT =',F8.4)
           ENDIF
@@ -114,7 +134,14 @@
         NLOOP=0
         COEF=(XSQ-A)/(8.*(1.-X)+XSQ+A)
  30       NLOOP=NLOOP+1
+#if !defined(CERNLIB_GFORTRAN)
           IF (NLOOP.GT.NBTRY) CALL HWWARN('HWHIGZ',102,*999)
+#else
+          if (NLOOP.GT.NBTRY) then
+          call hwwarn('HWHIGZ',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           CHIGG=HWRUNI(2,-ONE, ONE)
           PTHETA=1-COEF*CHIGG**2
         IF (PTHETA.LT.HWRGEN(1)) GOTO 30
@@ -150,7 +177,14 @@
         PHEP(5,IFER)=0
         PHEP(5,IANT)=0
  50     NLOOP=NLOOP+1
+#if !defined(CERNLIB_GFORTRAN)
         IF (NLOOP.GT.NBTRY) CALL HWWARN('HWHIGZ',103,*999)
+#else
+        if (NLOOP.GT.NBTRY) then
+          call hwwarn('HWHIGZ',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         CALL HWDTWO(PHEP(1,IZED),PHEP(1,IFER),PHEP(1,IANT),
      &              PCM,TWO,.TRUE.)
         PROB=C1*(PHEP(4,IFER)*PHEP(4,IANT)-PHEP(3,IFER)*PHEP(3,IANT))
diff -uNr src.ORIG/mclibs/herwig/code/hwhph2.F src/mclibs/herwig/code/hwhph2.F
--- src.ORIG/mclibs/herwig/code/hwhph2.F	1996-12-03 23:16:57.000000000 +0900
+++ src/mclibs/herwig/code/hwhph2.F	2005-05-31 02:34:40.000000000 +0900
@@ -47,7 +47,12 @@
         IF (DISF(13,1).GT.EPS.AND.DISF(13,2).GT.EPS) THEN
            TQSQ=0.
            DO 10 ID=1,6
+#if !defined(CERNLIB_GFORTRAN)
   10       IF (RMASS(ID).LT.RS) TQSQ=TQSQ+QFCH(ID)**2
+#else
+              IF (RMASS(ID).LT.RS) TQSQ=TQSQ+QFCH(ID)**2
+  10       continue
+#endif
            DSTU=DISF(13,1)*DISF(13,2)*FACT*HWHPPB(S,T,U)
      &         /64.*(HWUALF(1,EMSCA)*TQSQ/PIFAC)**2
         ENDIF
diff -uNr src.ORIG/mclibs/herwig/code/hwhpho.F src/mclibs/herwig/code/hwhpho.F
--- src.ORIG/mclibs/herwig/code/hwhpho.F	1996-12-03 23:16:57.000000000 +0900
+++ src/mclibs/herwig/code/hwhpho.F	2005-05-31 02:34:40.000000000 +0900
@@ -53,7 +53,12 @@
         IF (DISF(13,1).GT.EPS.AND.DISF(13,2).GT.EPS) THEN
            TQCH=0.
            DO 10 ID=1,6
+#if !defined(CERNLIB_GFORTRAN)
   10       IF (RMASS(ID).LT.RS) TQCH=TQCH+QFCH(ID)
+#else
+              IF (RMASS(ID).LT.RS) TQCH=TQCH+QFCH(ID)
+  10       continue
+#endif
            DSTU=DISF(13,1)*DISF(13,2)*FACT*HWHPPB(S,T,U)
      &         *5./768.*(HWUALF(1,EMSCA)*TQCH/PIFAC)**2
         ENDIF
diff -uNr src.ORIG/mclibs/herwig/code/hwhppm.F src/mclibs/herwig/code/hwhppm.F
--- src.ORIG/mclibs/herwig/code/hwhppm.F	1996-12-03 23:16:57.000000000 +0900
+++ src/mclibs/herwig/code/hwhppm.F	2005-05-31 02:34:40.000000000 +0900
@@ -73,7 +73,12 @@
          CALL HWSFUN(XX(2),EMSCA,IDHW(IHAD2),NSTRU,DISF(1,2),2)
          DO 10 I=1,3
          DO 10 J=1,3
+#if !defined(CERNLIB_GFORTRAN)
  10      DELT(I,J)=(QFCH(I)*U+QFCH(J)*S)**2
+#else
+            DELT(I,J)=(QFCH(I)*U+QFCH(J)*S)**2
+ 10      continue
+#endif
          C1STU=-(S**2+U**2)/(T*S**2*U**2)
          C3STU=-8.D0*T/(S**2*U**2)
       ENDIF
diff -uNr src.ORIG/mclibs/herwig/code/hwhqcd.F src/mclibs/herwig/code/hwhqcd.F
--- src.ORIG/mclibs/herwig/code/hwhqcd.F	1996-12-03 23:16:57.000000000 +0900
+++ src/mclibs/herwig/code/hwhqcd.F	2005-05-31 02:34:21.000000000 +0900
@@ -7,6 +7,9 @@
 C     QCD HARD 2->2 PROCESSES: MEAN EVWGT = SIGMA IN NB
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWRUNI,HWUALF,RS,EPS,HF,RCS,Z1,Z2,ET,EJ,
      & FACTR,S,T,U,ST,TU,US,STU,TUS,UST,EN,RN,GFLA,AF,ASTU,ASUT,AUST,
      & BF,BSTU,BSUT,BUST,BUTS,CF,CSTU,CSUT,CTSU,CTUS,DF,DSTU,DTSU,DUTS,
@@ -43,7 +46,14 @@
     3   CONTINUE
         I=NFLAV+1
     4   MAXFL=I-1
+#if !defined(CERNLIB_GFORTRAN)
         IF (MAXFL.EQ.0) CALL HWWARN('HWHQCD',100,*999)
+#else
+        if (MAXFL.EQ.0) then
+          call hwwarn('HWHQCD',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C
         T=-HF*S*(1.-COSTH)
         U=-S-T
diff -uNr src.ORIG/mclibs/herwig/code/hwhrem.F src/mclibs/herwig/code/hwhrem.F
--- src.ORIG/mclibs/herwig/code/hwhrem.F	1996-12-03 23:16:57.000000000 +0900
+++ src/mclibs/herwig/code/hwhrem.F	2005-05-31 02:34:21.000000000 +0900
@@ -8,6 +8,9 @@
 C     AND BREAK THEIR COLOUR CONNECTION IF NECESSARY
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION PCL(5)
       INTEGER IBEAM,ITARG,IHEP,NTEMP,I,ICOL,IANT
       LOGICAL LTEMP,T,COL,ANT
@@ -19,15 +22,43 @@
       ITARG=0
       DO 10 IHEP=1,NHEP
         IF (ISTHEP(IHEP).EQ.148) THEN
+#if !defined(CERNLIB_GFORTRAN)
           IF (ITARG.NE.0) CALL HWWARN('HWHREM',100,*999)
+#else
+          if (ITARG.NE.0) then
+          call hwwarn('HWHREM',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           ITARG=IHEP
         ELSEIF (ISTHEP(IHEP).EQ.147) THEN
+#if !defined(CERNLIB_GFORTRAN)
           IF (IBEAM.NE.0) CALL HWWARN('HWHREM',101,*999)
+#else
+          if (IBEAM.NE.0) then
+          call hwwarn('HWHREM',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           IBEAM=IHEP
         ENDIF
   10  CONTINUE
+#if !defined(CERNLIB_GFORTRAN)
       IF (ITARG.EQ.0) CALL HWWARN('HWHREM',102,*999)
+#else
+      if (ITARG.EQ.0) then
+          call hwwarn('HWHREM',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
       IF (IBEAM.EQ.0) CALL HWWARN('HWHREM',103,*999)
+#else
+      if (IBEAM.EQ.0) then
+          call hwwarn('HWHREM',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C---IF THEY ARE COLOUR CONNECTED, DISCONNECT THEM BY EMITTING A SOFT
 C   GLUON AND SPLITTING THAT GLUON TO LIGHT QUARKS
 C  (WHICH NORMALLY GETS DONE AS THE FIRST STAGE OF CLUSTER FORMATION)
diff -uNr src.ORIG/mclibs/herwig/code/hwhsct.F src/mclibs/herwig/code/hwhsct.F
--- src.ORIG/mclibs/herwig/code/hwhsct.F	1996-12-03 23:16:57.000000000 +0900
+++ src/mclibs/herwig/code/hwhsct.F	2005-05-31 02:34:21.000000000 +0900
@@ -15,6 +15,9 @@
 C     5 = COMPLETELY FAILED (IERROR IS ALSO NON-ZERO TO CANCEL EVENT)
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,TMPWGT,PBOOST(5),RBOOST(3,3)
       INTEGER IHEP,IBM,ITG,IBMN,ITGN,IBMT,ITGT,I,REPORT
       LOGICAL COL
@@ -169,7 +172,12 @@
 C---LOOK FOR COLOUR SINGLET GLUONS (A RARE BUT ANNOYING SPECIAL CASE)
       DO 20 IHEP=1,NHEP
         IF (IDHW(IHEP).EQ.13.AND.JMOHEP(2,IHEP).EQ.IHEP)
+#if !defined(CERNLIB_GFORTRAN)
      $       CALL HWWARN('HWHSCT',120,*999)
+#else
+     $       call hwwarn('HWHSCT',120,iret)
+        if (iret .eq. 1) go to 999
+#endif
  20   CONTINUE
       REPORT=0
  999  END
diff -uNr src.ORIG/mclibs/herwig/code/hwhv1j.F src/mclibs/herwig/code/hwhv1j.F
--- src.ORIG/mclibs/herwig/code/hwhv1j.F	1996-12-03 23:16:57.000000000 +0900
+++ src/mclibs/herwig/code/hwhv1j.F	2005-05-31 02:34:40.000000000 +0900
@@ -31,7 +31,12 @@
         DO 110 I=1,2
         DO 110 J=1,12
         DO 110 K=1,2
+#if !defined(CERNLIB_GFORTRAN)
  110      DISMAX=MAX(DISFAC(K,J,I),DISMAX)
+#else
+            DISMAX=MAX(DISFAC(K,J,I),DISMAX)
+ 110      continue
+#endif
  120    I=HWRINT(1,2)
         J=HWRINT(1,12)
         K=HWRINT(1,2)
@@ -73,7 +78,12 @@
         M=K
         IF (I.EQ.2.AND.J.LE.6) M=3-K
         DO 130 L=1,4
+#if !defined(CERNLIB_GFORTRAN)
  130      ICO(L)=ICOFLO(L,M)
+#else
+            ICO(L)=ICOFLO(L,M)
+ 130      continue
+#endif
         IDCMF=15
         COSTH=(SHAT+2*THAT-EMV2)/(SHAT-EMV2)
 C---TRICK HWETWO INTO USING THE OFF-SHELL V MASS
@@ -176,7 +186,12 @@
         DO 230 I=1,2
         DO 230 J=1,12
         DO 230 K=1,2
+#if !defined(CERNLIB_GFORTRAN)
  230      EVWGT=EVWGT+DISFAC(K,J,I)
+#else
+            EVWGT=EVWGT+DISFAC(K,J,I)
+ 230      continue
+#endif
         CSFAC=-PT*S/(XX(1)*S+U-EMV2)*EJ
      &        *(YMAX-YMIN)*XLMIN*XX(1)
 C---INCLUDE BRANCHING RATIO OF V
diff -uNr src.ORIG/mclibs/herwig/code/hwhwex.F src/mclibs/herwig/code/hwhwex.F
--- src.ORIG/mclibs/herwig/code/hwhwex.F	1996-12-03 23:16:57.000000000 +0900
+++ src/mclibs/herwig/code/hwhwex.F	2005-05-31 02:34:21.000000000 +0900
@@ -12,6 +12,9 @@
 C   (1-8) ARE WITH B FROM BEAM 1, (9-16) ARE WITH B FROM BEAM 2.
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWRUNI,DSDCOS(16),EMT2,EMT,EMW2,EMW,
      & CMFMIN,TAUMIN,TAUMLN,S,T,U,ROOTS,DSMAX
       INTEGER HWRINT,IDHWEX(2,16),I
@@ -65,7 +68,12 @@
 C---IF USER SPECIFIED SUB-PROCESS THEN ZERO ALL THE OTHERS
         IHPRO=MOD(IPROC,100)
         IF (IHPRO.GT.8) THEN
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWHWEX',1,*999)
+#else
+          call hwwarn('HWHWEX',1,iret)
+        if (iret .eq. 1) go to 999
+#endif
           IHPRO=0
         ENDIF
         DO 100 I=1,8
diff -uNr src.ORIG/mclibs/herwig/code/hwigin.F src/mclibs/herwig/code/hwigin.F
--- src.ORIG/mclibs/herwig/code/hwigin.F	1996-12-03 23:16:57.000000000 +0900
+++ src/mclibs/herwig/code/hwigin.F	2005-05-31 02:34:40.000000000 +0900
@@ -91,6 +91,7 @@
 C Note require POLN(1)**2+POLN(2)**2+POLN(3)**2 < 1.
       DO 20 I=1,3
       EPOLN(I)=0.
+#if !defined(CERNLIB_GFORTRAN)
   20  PPOLN(I)=0.
 C-----------------------------------------------------------------------
 C     Specify couplings of weak vector bosons to fermions:
@@ -108,6 +109,10 @@
 C Minimal standard model neutral vector boson couplings
 C VFCH(I,1)=(T3/2-Q*S^2_W)/(C_W*S_W);  AFCH(I,1)=T3/(2*C_W*S_W)
 C sin**2 Weinberg angle (PDG '94)
+#else
+         PPOLN(I)=0.
+  20  continue
+#endif
       SWEIN=.2319
       FAC=1./SQRT(SWEIN*(1.-SWEIN))
       DO 30 I=1,3
@@ -160,6 +165,7 @@
       DO 50 I=1,12
       BRHIG(I)=1.D0/12
       ENHANC(I)=1.D0
+#if !defined(CERNLIB_GFORTRAN)
  50   IF (I.LE.MODMAX) MODBOS(I)=0
 C
 C THE iTH GAUGE BOSON DECAY PER EVENT IS CONTROLLED BY MODBOS AS FOLLOWS
@@ -176,6 +182,10 @@
 C BOSON PAIRS (eg FROM HIGGS DECAY) ARE CHOSEN FROM MODBOS(i),MODBOS(i+1
 C
 C---CONTROL OF LARGE EMH BEHAVIOUR (SEE HWHIGM FOR DETAILS)
+#else
+         IF (I.LE.MODMAX) MODBOS(I)=0
+ 50   continue
+#endif
       IOPHIG=3
       GAMMAX=10.
 C Specicify approximation used in HWHIGA
@@ -322,8 +332,13 @@
 C   Veto cluster decays into particle type I
       VTOCDK(I)=.FALSE.
 C   Veto unstable particle decays into modes involving particle type I
+#if !defined(CERNLIB_GFORTRAN)
   60  VTORDK(I)=.FALSE.
 C---MINIMUM AND MAXIMUM S-HAT/S RANGE FOR PHOTON ISR
+#else
+         VTORDK(I)=.FALSE.
+  60  continue
+#endif
       TMNISR=1D-4
       ZMXISR=1-1D-6
 C---COLISR IS .TRUE. TO MAKE ISR PHOTONS COLLINEAR WITH BEAMS
@@ -333,8 +348,13 @@
       DO 70 N=0,4
       DO 70 J=0,4
       DO 70 L=0,3
+#if !defined(CERNLIB_GFORTRAN)
   70  REPWT(L,J,N)=1.
 C and singlet (Lambda-like) and decuplet barons
+#else
+         REPWT(L,J,N)=1.
+  70  continue
+#endif
       SNGWT=1.
       DECWT=1.
 C---A PRIORI WEIGHTS FOR D,U,S,C,B,T QUARKS AND DIQUARKS (IN THAT ORDER)
